Getting Started
===============

To get started quickly, begin with the [Tutorial](/docs/tutorial.md) which provides a step by step overview of how to install Protractor, create test files, set up config files, and run tests.

Protractor needs two files to run, the test or spec file, and the configuration file. For additional information, see [Working with Spec and Config Files](/docs/api-overview.md).

When writing tests, keep in mind that Protractor is a wrapper around WebDriverJS. You may want to skim through the [WebDriverJS Users Guide](https://github.com/SeleniumHQ/selenium/wiki/WebDriverJs) before writing any tests.

The WebDriverJS API is based on promises. To learn more, check out [The WebDriver Control Flow](/docs/control-flow.md).

To learn how Protractor, Selenium Server, and Selenium WebDriver work together, take a look at [How It Works](/docs/infrastructure.md). 

Once you are familiar with Protractor, it is recommended that you start using Page Objects. For more information see [Using Page Objects to Organize Tests](/docs/page-objects.md).

For a complete list of the Protractor documentation, see the [Table of Contents](/docs/toc.md).
